Index: src/cpu/emulation/qemu-i386/northbridge.c
===================================================================
--- src/cpu/emulation/qemu-i386/northbridge.c	(revision 3092)
+++ src/cpu/emulation/qemu-i386/northbridge.c	(working copy)
@@ -138,7 +138,7 @@
 	}
 }
 
-struct chip_operations cpu_emulation_qemu_i386_ops = {
+struct chip_operations cpu_emulation_qemu_x86_ops = {
 	CHIP_NAME("QEMU Northbridge")
 	.enable_dev = enable_dev,
 };
Index: src/cpu/emulation/qemu-i386/chip.h
===================================================================
--- src/cpu/emulation/qemu-i386/chip.h	(revision 3092)
+++ src/cpu/emulation/qemu-i386/chip.h	(working copy)
@@ -1,6 +1,6 @@
-struct cpu_emulation_qemu_i386_config
+struct cpu_emulation_qemu_x86_config
 {
 };
 
-extern struct chip_operations cpu_emulation_qemu_i386_ops;
+extern struct chip_operations cpu_emulation_qemu_x86_ops;
 
Index: src/cpu/emulation/qemu-i386/northbridge.h
===================================================================
--- src/cpu/emulation/qemu-i386/northbridge.h	(revision 3092)
+++ src/cpu/emulation/qemu-i386/northbridge.h	(working copy)
@@ -1,5 +1,5 @@
-#ifndef NORTHBRIDGE_EMULATION_QEMU_I386_H
-#define NORTHBRIDGE_EMULATION_QEMU_I386_H
+#ifndef NORTHBRIDGE_EMULATION_QEMU_X86_H
+#define NORTHBRIDGE_EMULATION_QEMU_X86_H
 
 
-#endif /* NORTHBRIDGE_EMULATION_QEMU_I386 */
+#endif /* NORTHBRIDGE_EMULATION_QEMU_X86 */
Index: src/mainboard/emulation/qemu-i386/Config.lb
===================================================================
--- src/mainboard/emulation/qemu-i386/Config.lb	(revision 3092)
+++ src/mainboard/emulation/qemu-i386/Config.lb	(working copy)
@@ -104,7 +104,7 @@
 dir /pc80
 config chip.h
 
-chip cpu/emulation/qemu-i386
+chip cpu/emulation/qemu-x86
 	device pci_domain 0 on 
 		device pci 0.0 on end
 		device pci 1.0 on end
Index: src/mainboard/emulation/qemu-i386/chip.h
===================================================================
--- src/mainboard/emulation/qemu-i386/chip.h	(revision 3092)
+++ src/mainboard/emulation/qemu-i386/chip.h	(working copy)
@@ -1,4 +1,4 @@
-extern struct chip_operations mainboard_emulation_qemu_i386_ops;
+extern struct chip_operations mainboard_emulation_qemu_x86_ops;
 
-struct mainboard_emulation_qemu_i386_config {
+struct mainboard_emulation_qemu_x86_config {
 };
Index: src/mainboard/emulation/qemu-i386/mainboard.c
===================================================================
--- src/mainboard/emulation/qemu-i386/mainboard.c	(revision 3092)
+++ src/mainboard/emulation/qemu-i386/mainboard.c	(working copy)
@@ -33,7 +33,7 @@
 	.device = 0x00b8,
 };
 
-struct chip_operations mainboard_emulation_qemu_i386_ops = {
+struct chip_operations mainboard_emulation_qemu_x86_ops = {
 	CHIP_NAME("QEMU Mainboard")
 };
 
Index: targets/emulation/qemu-i386/Config-abuild.lb
===================================================================
--- targets/emulation/qemu-i386/Config-abuild.lb	(revision 3092)
+++ targets/emulation/qemu-i386/Config-abuild.lb	(working copy)
@@ -1,7 +1,7 @@
-# This will make a target directory of ./emulation_qemu-i386
+# This will make a target directory of ./emulation_qemu-x86
 
-target emulation_qemu-i386
-mainboard emulation/qemu-i386
+target emulation_qemu-x86
+mainboard emulation/qemu-x86
 
 __COMPRESSION__
 
Index: targets/emulation/qemu-i386/Config.lb
===================================================================
--- targets/emulation/qemu-i386/Config.lb	(revision 3092)
+++ targets/emulation/qemu-i386/Config.lb	(working copy)
@@ -1,7 +1,7 @@
-# This will make a target directory of ./emulation_qemu-i386
+# This will make a target directory of ./emulation_qemu-x86
 
-target qemu-i386
-mainboard emulation/qemu-i386
+target qemu-x86
+mainboard emulation/qemu-x86
 
 option ROM_SIZE=256*1024
 
Index: targets/emulation/qemu-i386/Config-lab.lb
===================================================================
--- targets/emulation/qemu-i386/Config-lab.lb	(revision 3092)
+++ targets/emulation/qemu-i386/Config-lab.lb	(working copy)
@@ -1,7 +1,7 @@
-# This will make a target directory of ./emulation_qemu-i386
+# This will make a target directory of ./emulation_qemu-x86
 
-target qemu-i386
-mainboard emulation/qemu-i386
+target qemu-x86
+mainboard emulation/qemu-x86
 
 option ROM_SIZE=2048*1024
 option CONFIG_COMPRESSED_PAYLOAD_LZMA=0
Index: targets/emulation/qemu-i386/Config.OLPC.lb
===================================================================
--- targets/emulation/qemu-i386/Config.OLPC.lb	(revision 3092)
+++ targets/emulation/qemu-i386/Config.OLPC.lb	(working copy)
@@ -1,7 +1,7 @@
-# This will make a target directory of ./emulation_qemu-i386
+# This will make a target directory of ./emulation_qemu-x86
 
-target qemu-i386-OLPC
-mainboard emulation/qemu-i386
+target qemu-x86-OLPC
+mainboard emulation/qemu-x86
 
 option ROM_SIZE=1024*1024 - (128 * 1024)
 option CONFIG_COMPRESSED_PAYLOAD_LZMA=1