diff -BurN --exclude=.svn LinuxBIOSv2.old/src/arch/i386/Config.lb LinuxBIOSv2/src/arch/i386/Config.lb
--- LinuxBIOSv2.old/src/arch/i386/Config.lb	2006-10-09 16:18:01.000000000 +0000
+++ LinuxBIOSv2/src/arch/i386/Config.lb	2006-10-10 15:36:14.000000000 +0000
@@ -1,5 +1,5 @@
 uses CONFIG_SMP
-uses CONFIG_PRECOMPRESSED_ROM_STREAM
+uses CONFIG_PRECOMPRESSED_PAYLOAD
 uses CONFIG_USE_INIT
 uses HAVE_FAILOVER_BOOT
 uses USE_FAILOVER_IMAGE
@@ -61,11 +61,11 @@
 makedefine PAYLOAD-1:=payload
 
 # match the case where a compression type is specified.
-makedefine PAYLOAD-$(CONFIG_COMPRESSED_ROM_STREAM_NRV2B):=payload.nrv2b
-makedefine PAYLOAD-$(CONFIG_COMPRESSED_ROM_STREAM_LZMA):=payload.lzma
+makedefine PAYLOAD-$(CONFIG_COMPRESSED_PAYLOAD_NRV2B):=payload.nrv2b
+makedefine PAYLOAD-$(CONFIG_COMPRESSED_PAYLOAD_LZMA):=payload.lzma
 
 # catch the case where there is precompression. Yes, this bites. 
-if CONFIG_PRECOMPRESSED_ROM_STREAM 
+if CONFIG_PRECOMPRESSED_PAYLOAD 
 	makedefine PAYLOAD-1:=payload
 end
 
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/config/Options.lb LinuxBIOSv2/src/config/Options.lb
--- LinuxBIOSv2.old/src/config/Options.lb	2006-10-09 16:17:56.000000000 +0000
+++ LinuxBIOSv2/src/config/Options.lb	2006-10-10 15:43:43.000000000 +0000
@@ -609,25 +609,20 @@
 	export always
 	comment "ROM stream start location"
 end
-define CONFIG_COMPRESSED_ROM_STREAM
-	default 0
-	export always
-	comment "compressed boot image is located in ROM and is assumed to be NRV2B (deprecated)" 
-end
-define CONFIG_COMPRESSED_ROM_STREAM_NRV2B
+define CONFIG_COMPRESSED_PAYLOAD_NRV2B
 	default 0
 	export always
 	comment "NRV2B compressed boot image is located in ROM" 
 end
-define CONFIG_COMPRESSED_ROM_STREAM_LZMA
+define CONFIG_COMPRESSED_PAYLOAD_LZMA
 	default 0
 	export always
 	comment "LZMA compressed boot image is located in ROM" 
 end
-define CONFIG_PRECOMPRESSED_ROM_STREAM
+define CONFIG_PRECOMPRESSED_PAYLOAD
 	default 0
 	export always
-	comment "boot image is already compressed" 
+	comment "Boot image is already compressed prior to build"
 end
 define CONFIG_SERIAL_STREAM
 	default 0
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/mainboard/amd/rumba/Options.lb LinuxBIOSv2/src/mainboard/amd/rumba/Options.lb
--- LinuxBIOSv2.old/src/mainboard/amd/rumba/Options.lb	2006-10-09 16:17:51.000000000 +0000
+++ LinuxBIOSv2/src/mainboard/amd/rumba/Options.lb	2006-10-10 15:36:14.000000000 +0000
@@ -21,7 +21,7 @@
 uses ROM_SECTION_SIZE
 uses ROM_SECTION_OFFSET
 uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses _RAMBASE
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/mainboard/amd/serengeti_cheetah/Options.lb LinuxBIOSv2/src/mainboard/amd/serengeti_cheetah/Options.lb
--- LinuxBIOSv2.old/src/mainboard/amd/serengeti_cheetah/Options.lb	2006-10-09 16:17:52.000000000 +0000
+++ LinuxBIOSv2/src/mainboard/amd/serengeti_cheetah/Options.lb	2006-10-10 15:40:21.000000000 +0000
@@ -23,7 +23,7 @@
 uses ROM_SECTION_OFFSET
 uses CONFIG_ROM_STREAM
 uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses XIP_ROM_SIZE
@@ -267,7 +267,7 @@
 ##
 default CONFIG_ROM_STREAM = 1
 
-#default CONFIG_COMPRESSED_ROM_STREAM = 1
+#default CONFIG_COMPRESSED_PAYLOAD_NRV2B = 1
 
 ###
 ### Defaults of options that you may want to override in the target config file
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/mainboard/artecgroup/dbe61/Options.lb LinuxBIOSv2/src/mainboard/artecgroup/dbe61/Options.lb
--- LinuxBIOSv2.old/src/mainboard/artecgroup/dbe61/Options.lb	2006-10-09 16:17:53.000000000 +0000
+++ LinuxBIOSv2/src/mainboard/artecgroup/dbe61/Options.lb	2006-10-10 15:36:14.000000000 +0000
@@ -21,7 +21,7 @@
 uses ROM_SECTION_SIZE
 uses ROM_SECTION_OFFSET
 uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses _RAMBASE
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/mainboard/digitallogic/msm800sev/Options.lb LinuxBIOSv2/src/mainboard/digitallogic/msm800sev/Options.lb
--- LinuxBIOSv2.old/src/mainboard/digitallogic/msm800sev/Options.lb	2006-10-09 16:17:50.000000000 +0000
+++ LinuxBIOSv2/src/mainboard/digitallogic/msm800sev/Options.lb	2006-10-10 15:36:14.000000000 +0000
@@ -21,7 +21,7 @@
 uses ROM_SECTION_SIZE
 uses ROM_SECTION_OFFSET
 uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses _RAMBASE
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/mainboard/emulation/qemu-i386/Options.lb LinuxBIOSv2/src/mainboard/emulation/qemu-i386/Options.lb
--- LinuxBIOSv2.old/src/mainboard/emulation/qemu-i386/Options.lb	2006-10-09 16:17:51.000000000 +0000
+++ LinuxBIOSv2/src/mainboard/emulation/qemu-i386/Options.lb	2006-10-10 15:36:14.000000000 +0000
@@ -6,9 +6,9 @@
 uses HAVE_OPTION_TABLE
 uses USE_OPTION_TABLE
 uses CONFIG_COMPRESS
-uses CONFIG_COMPRESSED_ROM_STREAM_NRV2B
-uses CONFIG_COMPRESSED_ROM_STREAM_LZMA
-uses CONFIG_PRECOMPRESSED_ROM_STREAM
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_LZMA
+uses CONFIG_PRECOMPRESSED_PAYLOAD
 uses CONFIG_ROM_STREAM
 uses IRQ_SLOT_COUNT
 uses MAINBOARD
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/mainboard/olpc/rev_a/Options.lb LinuxBIOSv2/src/mainboard/olpc/rev_a/Options.lb
--- LinuxBIOSv2.old/src/mainboard/olpc/rev_a/Options.lb	2006-10-09 16:17:51.000000000 +0000
+++ LinuxBIOSv2/src/mainboard/olpc/rev_a/Options.lb	2006-10-10 15:36:14.000000000 +0000
@@ -21,9 +21,9 @@
 uses ROM_SECTION_SIZE
 uses ROM_SECTION_OFFSET
 uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM_NRV2B
-uses CONFIG_COMPRESSED_ROM_STREAM_LZMA
-uses CONFIG_PRECOMPRESSED_ROM_STREAM
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_LZMA
+uses CONFIG_PRECOMPRESSED_PAYLOAD
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses _RAMBASE
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/mainboard/technologic/ts5300/Options.lb LinuxBIOSv2/src/mainboard/technologic/ts5300/Options.lb
--- LinuxBIOSv2.old/src/mainboard/technologic/ts5300/Options.lb	2006-10-09 16:17:51.000000000 +0000
+++ LinuxBIOSv2/src/mainboard/technologic/ts5300/Options.lb	2006-10-10 15:36:14.000000000 +0000
@@ -6,7 +6,7 @@
 uses HAVE_OPTION_TABLE
 uses USE_OPTION_TABLE
 uses CONFIG_COMPRESS
-uses CONFIG_COMPRESSED_ROM_STREAM_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
 uses CONFIG_ROM_STREAM
 uses CONFIG_USE_INIT
 uses IRQ_SLOT_COUNT
@@ -134,7 +134,7 @@
 
 default _RAMBASE = 0x00004000
 
-default CONFIG_COMPRESSED_ROM_STREAM_NRV2B     = 1
+default CONFIG_COMPRESSED_PAYLOAD_NRV2B     = 1
 default CONFIG_ROM_STREAM     = 1
 
 ##
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/mainboard/via/epia-m/Options.lb LinuxBIOSv2/src/mainboard/via/epia-m/Options.lb
--- LinuxBIOSv2.old/src/mainboard/via/epia-m/Options.lb	2006-10-09 16:17:48.000000000 +0000
+++ LinuxBIOSv2/src/mainboard/via/epia-m/Options.lb	2006-10-10 15:36:14.000000000 +0000
@@ -21,7 +21,7 @@
 uses ROM_SECTION_SIZE
 uses ROM_SECTION_OFFSET
 uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses _RAMBASE
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/stream/rom_stream.c LinuxBIOSv2/src/stream/rom_stream.c
--- LinuxBIOSv2.old/src/stream/rom_stream.c	2006-10-09 16:17:47.000000000 +0000
+++ LinuxBIOSv2/src/stream/rom_stream.c	2006-10-10 15:42:56.000000000 +0000
@@ -5,23 +5,23 @@
 #include <string.h>
 
 /* if they set the precompressed rom stream, they better have set a type */
-#if CONFIG_PRECOMPRESSED_ROM_STREAM && ((!CONFIG_COMPRESSED_ROM_STREAM) && (!CONFIG_COMPRESSED_ROM_STREAM_NRV2B) && (!CONFIG_COMPRESSED_ROM_STREAM_LZMA))
-#error "You set CONFIG_PRECOMPRESSED_ROM_STREAM but need to set CONFIG_COMPRESSED_ROM_STREAM (implies NRV2B, deprecated) or CONFIG_COMPRESSED_ROM_STREAM_NRV2B or CONFIG_COMPRESSED_ROM_STREAM_LZMA"
+#if CONFIG_PRECOMPRESSED_PAYLOAD && ((!CONFIG_COMPRESSED_PAYLOAD_NRV2B) && (!CONFIG_COMPRESSED_PAYLOAD_LZMA))
+#error "You set CONFIG_PRECOMPRESSED_PAYLOAD but need to set CONFIG_COMPRESSED_PAYLOAD_NRV2B or CONFIG_COMPRESSED_PAYLOAD_LZMA"
 #endif
 
 /* If they set ANY of these, then we're compressed */
-#if ((CONFIG_COMPRESSED_ROM_STREAM) || (CONFIG_COMPRESSED_ROM_STREAM_NRV2B) || (CONFIG_COMPRESSED_ROM_STREAM_LZMA))
+#if ((CONFIG_COMPRESSED_PAYLOAD_NRV2B) || (CONFIG_COMPRESSED_PAYLOAD_LZMA))
 #define UNCOMPRESSER 1
 extern unsigned char _heap, _eheap;
 #endif
 
-#if (CONFIG_COMPRESSED_ROM_STREAM) || (CONFIG_COMPRESSED_ROM_STREAM_NRV2B) 
+#if (CONFIG_COMPRESSED_PAYLOAD_NRV2B) 
 #define HAVE_UNCOMPRESSER 1
 // include generic nrv2b
 #include "../lib/nrv2b.c"
 #endif
 
-#if (CONFIG_COMPRESSED_ROM_STREAM_LZMA)
+#if (CONFIG_COMPRESSED_PAYLOAD_LZMA)
 #if HAVE_UNCOMPRESSER
 #error "You're defining more than one compression type, which is not allowed (of course)"
 #endif
@@ -53,11 +53,11 @@
 unsigned long 
 uncompress(uint8_t * rom_start, uint8_t *dest )
 {
-#if (CONFIG_COMPRESSED_ROM_STREAM) || (CONFIG_COMPRESSED_ROM_STREAM_NRV2B) 
+#if (CONFIG_COMPRESSED_PAYLOAD_NRV2B) 
 	unsigned long ilen; // used compressed stream length
 	return unrv2b(rom_start, dest, &ilen);
 #endif
-#if (CONFIG_COMPRESSED_ROM_STREAM_LZMA)
+#if (CONFIG_COMPRESSED_PAYLOAD_LZMA)
 	return ulzma(rom_start, dest);
 #endif
 }
diff -BurN --exclude=.svn LinuxBIOSv2.old/src/stream/serial_stream.c LinuxBIOSv2/src/stream/serial_stream.c
--- LinuxBIOSv2.old/src/stream/serial_stream.c	2006-10-09 16:17:47.000000000 +0000
+++ LinuxBIOSv2/src/stream/serial_stream.c	2006-10-10 15:41:54.000000000 +0000
@@ -5,16 +5,16 @@
 #include <string.h>
 
 /* if they set the precompressed rom stream, they better have set a type */
-#if CONFIG_PRECOMPRESSED_ROM_STREAM && ((!CONFIG_COMPRESSED_ROM_STREAM) && (!CONFIG_COMPRESSED_ROM_STREAM_NRV2B) && (!CONFIG_COMPRESSED_ROM_STREAM_LZMA))
-#error "You set CONFIG_PRECOMPRESSED_ROM_STREAM but need to set CONFIG_COMPRESSED_ROM_STREAM (implies NRV2B, deprecated) or CONFIG_COMPRESSED_ROM_STREAM_NRV2B or CONFIG_COMPRESSED_ROM_STREAM_LZMA"
+#if CONFIG_PRECOMPRESSED_PAYLOAD && ((!CONFIG_COMPRESSED_PAYLOAD_NRV2B) && (!CONFIG_COMPRESSED_PAYLOAD_LZMA))
+#error "You set CONFIG_PRECOMPRESSED_PAYLOAD but need to set CONFIG_COMPRESSED_PAYLOAD_NRV2B or CONFIG_COMPRESSED_PAYLOAD_LZMA"
 #endif
 
-#if (CONFIG_COMPRESSED_ROM_STREAM) || (CONFIG_COMPRESSED_ROM_STREAM_NRV2B) 
+#if (CONFIG_COMPRESSED_PAYLOAD_NRV2B) 
 #define HAVE_UNCOMPRESSER 1
 #include "../lib/nrv2b.c"
 #endif
 
-#if (CONFIG_COMPRESSED_ROM_STREAM_LZMA)
+#if (CONFIG_COMPRESSED_PAYLOAD_LZMA)
 #if HAVE_UNCOMPRESSER
 #error "You're defining more than one compression type, which is not allowed (of course)"
 #endif
@@ -33,11 +33,11 @@
 #if HAVE_UNCOMPRESSER
 static unsigned long uncompress(uint8_t *src, uint8_t *dest)
 {
-#if (CONFIG_COMPRESSED_ROM_STREAM) || (CONFIG_COMPRESSED_ROM_STREAM_NRV2B) 
+#if (CONFIG_COMPRESSED_PAYLOAD_NRV2B) 
 	unsigned long ilen;
 	return unrv2b(src, dest, &ilen);
 #endif
-#if (CONFIG_COMPRESSED_ROM_STREAM_LZMA)
+#if (CONFIG_COMPRESSED_PAYLOAD_LZMA)
 	return ulzma(src, dest);
 #endif
 }
diff -BurN --exclude=.svn LinuxBIOSv2.old/targets/artecgroup/dbe61/Config.lb LinuxBIOSv2/targets/artecgroup/dbe61/Config.lb
--- LinuxBIOSv2.old/targets/artecgroup/dbe61/Config.lb	2006-10-09 16:18:03.000000000 +0000
+++ LinuxBIOSv2/targets/artecgroup/dbe61/Config.lb	2006-10-10 15:36:08.000000000 +0000
@@ -3,7 +3,7 @@
 target dbe61
 mainboard artecgroup/dbe61
 
-option CONFIG_COMPRESSED_ROM_STREAM_NRV2B=0
+option CONFIG_COMPRESSED_PAYLOAD_NRV2B=0
 
 ## ROM_SIZE is the total number of bytes allocated for LinuxBIOS use
 ## (normal AND fallback images and payloads).
diff -BurN --exclude=.svn LinuxBIOSv2.old/targets/digitallogic/msm800sev/Config.lb LinuxBIOSv2/targets/digitallogic/msm800sev/Config.lb
--- LinuxBIOSv2.old/targets/digitallogic/msm800sev/Config.lb	2006-10-09 16:18:03.000000000 +0000
+++ LinuxBIOSv2/targets/digitallogic/msm800sev/Config.lb	2006-10-10 15:36:09.000000000 +0000
@@ -3,7 +3,7 @@
 target msm800sev
 mainboard digitallogic/msm800sev
 
-option CONFIG_COMPRESSED_ROM_STREAM_NRV2B=0
+option CONFIG_COMPRESSED_PAYLOAD_NRV2B=0
 
 ## ROM_SIZE is the total number of bytes allocated for LinuxBIOS use
 ## (normal AND fallback images and payloads).
diff -BurN --exclude=.svn LinuxBIOSv2.old/targets/emulation/qemu-i386/Config.OLPC.lb LinuxBIOSv2/targets/emulation/qemu-i386/Config.OLPC.lb
--- LinuxBIOSv2.old/targets/emulation/qemu-i386/Config.OLPC.lb	2006-10-09 16:18:03.000000000 +0000
+++ LinuxBIOSv2/targets/emulation/qemu-i386/Config.OLPC.lb	2006-10-10 15:36:09.000000000 +0000
@@ -4,8 +4,8 @@
 mainboard emulation/qemu-i386
 
 option ROM_SIZE=1024*1024 - (128 * 1024)
-option CONFIG_COMPRESSED_ROM_STREAM_LZMA=1
-option CONFIG_PRECOMPRESSED_ROM_STREAM=0
+option CONFIG_COMPRESSED_PAYLOAD_LZMA=1
+option CONFIG_PRECOMPRESSED_PAYLOAD=0
 
 option CC="gcc -m32"
 
diff -BurN --exclude=.svn LinuxBIOSv2.old/targets/olpc/rev_a/Config.1M.lb LinuxBIOSv2/targets/olpc/rev_a/Config.1M.lb
--- LinuxBIOSv2.old/targets/olpc/rev_a/Config.1M.lb	2006-10-09 16:18:03.000000000 +0000
+++ LinuxBIOSv2/targets/olpc/rev_a/Config.1M.lb	2006-10-10 15:36:07.000000000 +0000
@@ -4,8 +4,8 @@
 mainboard olpc/rev_a
 
 # Don't let LinuxBIOS compress the payload
-# option CONFIG_COMPRESSED_ROM_STREAM_NRV2B=0
-#option CONFIG_PRECOMPRESSED_ROM_STREAM=1
+# option CONFIG_COMPRESSED_PAYLOAD_NRV2B=0
+#option CONFIG_PRECOMPRESSED_PAYLOAD=1
 
 # leave 64k for vsa
 option ROM_SIZE=(1024*1024)-(64*1024)
diff -BurN --exclude=.svn LinuxBIOSv2.old/targets/olpc/rev_a/Config.lb LinuxBIOSv2/targets/olpc/rev_a/Config.lb
--- LinuxBIOSv2.old/targets/olpc/rev_a/Config.lb	2006-10-09 16:18:03.000000000 +0000
+++ LinuxBIOSv2/targets/olpc/rev_a/Config.lb	2006-10-10 15:36:08.000000000 +0000
@@ -4,7 +4,7 @@
 mainboard olpc/rev_a
 
 # leave 64k for vsa
-option CONFIG_COMPRESSED_ROM_STREAM_NRV2B=0
+option CONFIG_COMPRESSED_PAYLOAD_NRV2B=0
 option ROM_SIZE=512*1024-64*1024
 option FALLBACK_SIZE=ROM_SIZE
 
diff -BurN --exclude=.svn LinuxBIOSv2.old/targets/olpc/rev_a/Config.SPI.lb LinuxBIOSv2/targets/olpc/rev_a/Config.SPI.lb
--- LinuxBIOSv2.old/targets/olpc/rev_a/Config.SPI.lb	2006-10-09 16:18:03.000000000 +0000
+++ LinuxBIOSv2/targets/olpc/rev_a/Config.SPI.lb	2006-10-10 15:36:07.000000000 +0000
@@ -4,9 +4,9 @@
 mainboard olpc/rev_a
 
 # Don't let LinuxBIOS compress the payload
-#option CONFIG_COMPRESSED_ROM_STREAM_NRV2B=0
-#option CONFIG_COMPRESSED_ROM_STREAM_LZMA=1
-#option CONFIG_PRECOMPRESSED_ROM_STREAM=0
+#option CONFIG_COMPRESSED_PAYLOAD_NRV2B=0
+#option CONFIG_COMPRESSED_PAYLOAD_LZMA=1
+#option CONFIG_PRECOMPRESSED_PAYLOAD=0
 
 # leave 64k for vsa and 64k for EC code
 option ROM_SIZE=(1024*1024)-(64*1024)-(64*1024)
diff -BurN --exclude=.svn LinuxBIOSv2.old/targets/via/epia-m/Config.lb LinuxBIOSv2/targets/via/epia-m/Config.lb
--- LinuxBIOSv2.old/targets/via/epia-m/Config.lb	2006-10-09 16:18:03.000000000 +0000
+++ LinuxBIOSv2/targets/via/epia-m/Config.lb	2006-10-10 15:39:54.000000000 +0000
@@ -13,8 +13,8 @@
 option HAVE_OPTION_TABLE=1
 option CONFIG_ROM_STREAM=1
 option HAVE_FALLBACK_BOOT=1
-#option CONFIG_COMPRESSED_ROM_STREAM=1
-option CONFIG_COMPRESSED_ROM_STREAM=0
+#option CONFIG_COMPRESSED_PAYLOAD_NRV2B=1
+option CONFIG_COMPRESSED_PAYLOAD_NRV2B=0
 
 
 ###